
; Stanice slyiteln v Evrop:
; ---------------------------
;  DCF77 - Mainfligen (SRN)
;  HBG - Prangins (vcarsko)
;  MSF - Rugby (Velk Britnie)
;  OMA - Liblice (R) (viz AR 1976 a 1979)
;
; Vysla DCF je umstn v Mainfligenu pobl Frankfurtu nad Mohanem (SRN).
; Vysla vysl na kmitotu 77.5 kHz a m vkon 27 kW. Nepesnost daje
; je 2 * 10^-13 za 100 dn. Sekundov znaka je vytvoena zmenenm amplitudy
; nosn na 25 % na zatku kad sekundy. Dlka sekundov znaky je bu 100 ms
; (="0") nebo 200 ms (="1"). Bhem kad minuty je odvyslna pln asov
; informace mezi 20. a 58. sekundou - tj. stedoevropsk as, platn pro
; nsledujc minutu souasn s datem. Zatek penosu zan ve 20. sekund
; kad minuty odvyslnm sekundov znaky "1". Vechny daje jsou peneny
; v BCD kdu (od nejnich bit a od nejnich slic). daje minut jsou
; odvyslny mezi 21. a 27. sekundou (4 + 3 bity). V 28. sekund je vysln
; paritn bit pro minuty (sud parita). daje hodin jsou vyslny mezi
; 29. a 34. sekundou (4 + 2 bity), ve 35. sekund je vysln paritn bit pro
; hodiny. Mezi 36. a 41. sekundou je vysln den (4 + 2 bity), mezi
; 42. a 44. sekundou je vysln den v tdnu (3 bity, 0=nedle), mezi 45.
; a 49. sekundou je vysln msc a mezi 50. a 57. sekundou je vysln
; rok (4 + 4 bity, pouze 2 posledn slice bez stolet). V 58. sekund
; je vysln paritn bit pro datum. Zatek minuty se synchronizuje
; vyhodnocenm minutov znaky, kter je vytvoena chybjc sekundovou
; znakou v 59. sekund. Vysla DCF77 je v chodu nepetrit krom
; kadho druhho ter v msci mezi 5. a 9. hodinou (probh technick
; drba).


AdrMER   EQU       20*80*2                  ; adresa mtka
AdrBit   EQU       8*160                    ; adresa bit
AdrTim   EQU       12*160+2*25              ; adresa asu

bit0     EQU       1
bit1     EQU       2
bit2     EQU       4
bit3     EQU       8
bit4     EQU       10h
bit5     EQU       20h
bit6     EQU       40h
bit7     EQU       80h

Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

Start:   jmp       Instal

Port     dw        0                        ; slo portu COM - 1 (tj. 0 a 3)
AdrPort  dw        0                        ; adresa portu COM


; -----------------------------------------------------------------------------
;        instalace programu do pamti
; -----------------------------------------------------------------------------

; ------

Instal:


; ------ pprava k rozboru pkazovho dku

         mov       si,81h
         mov       cl,ds:[si-1]
         mov       ch,0
         cld

Instal2: jcxz      Instal3
         lodsb
         dec       cx
         cmp       al," "
         jbe       Instal2
         mov       ds:[InstTxt1],al
         sub       al,"1"
         jb        Chyba
         mov       byte ptr ds:[Port],al
         cmp       al,4
         jb        Instal3

Chyba:   mov       dx,offset HelpTxt
Chyba1:  mov       ah,9
         int       21h
         int       20h

; ------ adresa portu COM

Instal3: mov       ax,40h
         mov       es,ax
         mov       bx,ds:[Port]             ; slo portu COM
         shl       bx,1
         mov       ax,es:[bx]               ; AX <- adresa portu COM
         mov       dx,offset InstTxt
         or        ax,ax                    ; je port COM nainstalovn ?
         jz        Chyba1                   ; nen nainstalovn
         mov       ds:[AdrPort],ax          ; adresa portu COM

; ------ instalace INT 09h

         mov       ax,3509h
         int       21h
         mov       word ptr ds:[Old09],bx
         mov       word ptr ds:[Old09+2],es

         mov       dx,offset Int09
         mov       ax,2509h
         int       21h

; ------ instalace INT 08h

         mov       ax,3508h
         int       21h
         mov       word ptr ds:[Old08],bx
         mov       word ptr ds:[Old08+2],es

         mov       dx,offset Int08
         mov       ax,2508h
         int       21h

         mov       dx,offset Int23
         mov       ax,2523h
         int       21h
         mov       ax,2524h
         int       21h


         call      initDisp                 ; inicializan zobrazen

Instal6: sti
         call      Disp                     ; obsluha zobrazen

         test      byte ptr ds:[Param],bit0
         jz        Instal6



         push      ds
         lds       dx,ds:[Old08]
         mov       ax,2508h
         int       21h
         pop       ds

         push      ds
         lds       dx,ds:[Old09]
         mov       ax,2509h
         int       21h
         pop       ds

         call      DeInit                   ; nvrat nastaven hodin

         mov       ah,1
         int       16h
         jz        Instal9
         mov       ah,0
         int       16h
Instal9:

         call      InitVMod

         int       20h

Int23:   iret

; -----------------------------------------------------------------------------
;        inicializan zobrazen
; -----------------------------------------------------------------------------

InitDisp PROC      NEAR

         call      InitVMod                 ; inicializace videomdu

; ------ zobrazen linky mtka

         cld
         mov       es,ds:[AdrVRAM]          ; adresa videopamti
         mov       di,AdrMER                ; adresa mtka
         mov       ah,0ah
         mov       cx,80
         mov       si,offset MerTxt
InitDsp2:lodsb
         stosw
         loop      InitDsp2

         mov       ah,0fh
         mov       cl,80
InitDsp3:lodsb
         stosw
         loop      InitDsp3

         mov       ah,0eh
         mov       cl,2*80
InitDsp4:lodsb
         stosw
         loop      InitDsp4


         call      ImpVyp9                  ; zobrazen indiktoru

; ------ nastaven portu

         mov       dx,ds:[AdrPort]          ; adresa portu
         add       dx,4
         mov       al,9
         out       dx,al

         ret

InitDisp ENDP

; -----------------------------------------------------------------------------
;        obsluha zobrazen
; -----------------------------------------------------------------------------
;
XXXK     dd        1

XXX      dd        1

Disp     PROC      NEAR

         sub       word ptr ds:[xxx],1
         sbb       word ptr ds:[xxx+2],0
;         jnc        Disp4

         mov       ax,word ptr ds:[xxxk]
         mov       word ptr ds:[xxx],ax
         mov       ax,word ptr ds:[xxxk+2]
         mov       word ptr ds:[xxx+2],ax


; ------ naten stavu portu

         mov       dx,ds:[AdrPort]          ; adresa portu
         add       dx,6
         in        al,dx                    ; ten stavu modemu
         test      al,10h                   ; je signl ?
         jnz       Disp4                    ; signl je zapnut

; ------ test, zda je signl ji vypnut

Disp2:   test      byte ptr ds:[Param],bit1 ; je signl ji vypnut ?
         jz        Disp8                    ; signl je ji vypnut
         and       byte ptr ds:[Param],not bit1 ; vypnut signlu
         call      ImpVyp                   ; vypnut impulsu

;         sti
;         xor       ax,ax
;         mov       es,ax
;         mov       ax,es:[46ch]
;Disp5:   cmp       ax,es:[46ch]
;         je        Disp5


         jmp       short Disp8

; ------ test, zda je signl ji zapnut

Disp4:   test      byte ptr ds:[Param],bit1 ; je signl ji zapnut ?
         jnz       Disp8                    ; signl je ji zapnut
         or        byte ptr ds:[Param],bit1 ; zapnut signlu

         call      ImpZap                   ; zapnut impulsu

Disp8:   ret

Disp     ENDP

; -----------------------------------------------------------------------------
;        zapnut impulsu
; -----------------------------------------------------------------------------

ImpZap   PROC      NEAR

         mov       es,ds:[AdrVRAM]          ; adresa videopamti

; ------ naten asu

         call      GetTime                  ; naten asu
         cmp       dx,9                     ; je jen krtk prodleva ?
         jae       ImpZap2                  ; je dlouh as
         add       word ptr ds:[Stradac],ax
         adc       word ptr ds:[Stradac+2],dx
         jmp       short ImpZap8

; ------ impuls je platn

ImpZap2: cmp       word ptr ds:[Stradac+2],3 ; je to "1" ?
         mov       al,"1"                   ; je to "1"
         jae       ImpZap3                  ; je to "1"
         dec       ax                       ; jinak "0"
ImpZap3: mov       di,ds:[UkazBit]          ; ukazatel bit
         mov       byte ptr es:[di+160]," " ; vymazn ukazatele
         cld
         mov       ah,0eh
         stosw

         cmp       dx,20                    ; byla mezera ?
         jb        ImpZap4                  ; nebyla mezera
         mov       di,AdrBit                ; zatek dku

ImpZap4: cmp       di,AdrBit+2*79
         jbe       ImpZap5
         dec       di
         dec       di
ImpZap5: mov       ds:[UkazBit],di

         mov       al,30
         mov       ah,0bh
         mov       es:[di+160],ax

         xor       ax,ax
         mov       word ptr ds:[Stradac],ax
         mov       word ptr ds:[Stradac+2],ax

         call      DispTim                  ; zobrazen asu

; ------ zobrazen indiktoru

ImpZap8: mov       di,4*80*2 + 33*2
         mov       es,ds:[AdrVRAM]          ; adresa videopamti
         mov       ah,4
         cld
         mov       al,""                   ; svt
         mov       cx,14
         rep       stosw
         ret

ImpZap   ENDP

; -----------------------------------------------------------------------------
;        vypnut impulsu
; -----------------------------------------------------------------------------

ImpVyp   PROC      NEAR

; ------ naten asu -> DX:AX

         call      GetTime                  ; naten asu
         cmp       word ptr ds:[Stradac],0  ; je to prvn impuls ?
         jne       ImpVyp1                  ; nen prvn impuls
         cmp       word ptr ds:[Stradac+2],0
         jne       ImpVyp1                  ; nen prvn impuls
         or        dx,dx
         jnz       ImpVyp1                  ; impuls je dost dlouh
         cmp       ax,20000                 ; asi tak minimln 17 ms
         jb        ImpVyp2                  ; je jen krtk impuls
ImpVyp1: add       word ptr ds:[Stradac],ax
         adc       word ptr ds:[Stradac+2],dx

; ------ vpoet polohy indiktoru

ImpVyp2: mov       cx,3977                  ; dlitel pro pepoet
         cmp       dx,cx                    ; bylo by peteen ?
         jae       ImpVyp4                  ; bylo by peteen
         div       cx                       ; vpoet dlk
         cmp       ax,80                    ; peteen ?
         jae       ImpVyp4                  ; peteen

; ------ oznaen v map

         xchg      ax,bx                    ; BX <- poloha
         mov       byte ptr ds:[Mapa+bx],30 ; dlka trvn impulsu

; ------ zobrazen indiktoru

         mov       al,""
         mov       ah,4
         call      DispInd

; ------ vypnut indiktoru signlu (je volno pi startu !)

ImpVyp4:
ImpVyp9: mov       es,ds:[AdrVRAM]          ; adresa videopamti
         mov       di,4*80*2 + 33*2
         mov       al,""                   ; nesvt
         mov       ah,4
         cld
         mov       cx,14
         rep       stosw
         ret

ImpVyp   ENDP

; -----------------------------------------------------------------------------
;        obsluha dekdovn a zobrazen asu
; -----------------------------------------------------------------------------
;
DispTim  PROC      NEAR

         cld
         mov       es,ds:[AdrVRAM]          ; adresa videopamti
         mov       si,AdrBit+2*21
         mov       di,AdrBit + 3*160

         mov       ah,0fh

; ------ minuta (21 a 27)

         xor       cx,cx
         mov       bl,27
         call      Get4Nm
         call      Get3Nm
         mov       al,":"
         call      Get4NmCh

; ------ parita minut (28)

         call      GetBit                   ; parita minut

; ------ hodina (29 a 34)

         mov       bl,24
         xor       cx,cx
         call      Get4Nm
         call      Get2Nm

; ------ parita hodin (35)

         call      GetBit

; ------ den (36 a 41)

         mov       bl,10
         xor       cx,cx
         call      Get4Nm
         call      Get2Nm

; ------ den v tdnu (42 a 44)

         mov       bl,0
         call      Get3Nm

         push      si
         push      cx

         mov       di,AdrTim
         mov       bl,es:[di]
         mov       bh,0
         sub       bl,"0"
         shl       bx,1
         shl       bx,1
         shl       bx,1
         add       bx,offset DnyTxt
         mov       si,bx
         mov       cx,8
DispTim1:lodsb
         stosw
         loop      DispTim1

         pop       cx
         pop       si

; ------ msc (45 a 49)

         mov       bl,13
         call      Get4Nm
         call      Get1Nm
         mov       al,"."
         call      Get4NmCh

; ------ rok (50 a 57)

         mov       bl,18
         call      Get4Nm
         call      Get4Nm

         cmp       byte ptr es:[AdrTim+18*2-2],"8"
         jae       DispTim2

         mov       al,"0"
         call      Get4NmCh
         mov       al,"2"
         jmp       short DispTim3

DispTim2:mov       al,"9"
         call      Get4NmCh
         mov       al,"1"
DispTim3:call      Get4NmCh

         mov       al,"."
         call      Get4NmCh

; ------ parita pro datum

         call      GetBit

         ret

DispTim  ENDP

; -----------------------------------------------------------------------------
;     naten 1-bit slice AL z pozice ES:SI videopamti (CL=stada parity)
; -----------------------------------------------------------------------------

Get1Nm   PROC      NEAR

         mov       al,80h
         jmp       short Get4Nm1

Get1Nm   ENDP

; -----------------------------------------------------------------------------
;     naten 2-bit slice AL z pozice ES:SI videopamti (CL=stada parity)
; -----------------------------------------------------------------------------

Get2Nm   PROC      NEAR

         mov       al,80h
         jmp       short Get4Nm2

Get2Nm   ENDP

; -----------------------------------------------------------------------------
;     naten 3-bit slice AL z pozice ES:SI videopamti (CL=stada parity)
; -----------------------------------------------------------------------------

Get3Nm   PROC      NEAR

         mov       al,80h
         jmp       short Get4Nm3

Get3Nm   ENDP

; -----------------------------------------------------------------------------
;     naten 4-bit slice AL z pozice ES:SI videopamti (CL=stada parity)
; -----------------------------------------------------------------------------

Get4Nm   PROC      NEAR

         mov       al,80h
         call      GetBit
         rcr       al,1
Get4Nm3: call      GetBit
         rcr       al,1
Get4Nm2: call      GetBit
         rcr       al,1
Get4Nm1: call      GetBit
         rcr       al,1

Get4Nm0: shr       al,1
         jnc       Get4Nm0

         add       al,"0"                   ; korekce na ASCII znak

Get4NmCh:push      bx
         mov       bh,0
         shl       bx,1
         mov       es:[bx+AdrTim],ax
         pop       bx
         dec       bx
         ret

Get4Nm   ENDP

; -----------------------------------------------------------------------------
;        naten bitu z pozice ES:SI videopamti -> CY="1", CL=stada parity
; -----------------------------------------------------------------------------

GetBit   PROC      NEAR

         xor       cl,es:[si]
         and       cl,bit0

         cmp       byte ptr es:[si],"1"
         cmc
         inc       si
         inc       si
         ret

GetBit   ENDP

; -----------------------------------------------------------------------------
;        zobrazen indiktoru - pozice BX, znak AX
; -----------------------------------------------------------------------------

DispInd  PROC      NEAR

         push      bx
         push      es

         mov       es,ds:[AdrVRAM]
         shl       bx,1
         add       bx,AdrMER-2*80
         mov       es:[bx],ax
         mov       es:[bx-160],ax

         pop       es
         pop       bx
         ret

DispInd  ENDP

; -----------------------------------------------------------------------------
;        inicializace videomdu
; -----------------------------------------------------------------------------

InitVMod PROC      NEAR

         mov       ah,0fh
         call      Int10                    ; poskytnut videomdu

         cmp       al,7
         je        InitVMd2
         mov       al,3
         mov       byte ptr ds:[AdrVRAM+1],0b8h

InitVMd2:mov       ah,0
         mov       ds:[VMod],al
         call      Int10                    ; inicializace videomdu

         mov       dx,25*256
         mov       ah,2
         call      Int10                    ; vypnut kurzoru

         ret

InitVMod ENDP

; -----------------------------------------------------------------------------
;        naten tae asu -> DX:AX
; -----------------------------------------------------------------------------
;
GetTime  PROC      NEAR

         cli

         mov       al,34h

         out       [43h],al
         jmp       $+2
         jmp       $+2
         jmp       $+2
         in        al,[40h]
         jmp       $+2
         jmp       $+2
         jmp       $+2
         mov       ah,al
         in        al,[40h]
         xchg      al,ah
         neg       ax

         push      ax
         xor       ax,ax
         out       [40h],al
         jmp       $+2
         jmp       $+2
         jmp       $+2
         out       [40h],al
         pop       ax

         xor       dx,dx                    ; DX <- 0
         xchg      dx,ds:[Cit08]            ; naten a nulovn tae INT 08

         sti
         ret

GetTime  ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 10h
; -----------------------------------------------------------------------------

Int10    PROC      NEAR

         push      si
         push      di
         push      bp
         push      ds
         push      es

         int       10h

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         ret

Int10    ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 09h
; -----------------------------------------------------------------------------

Int09    PROC      FAR

         push      ax
         push      es

         xor       ax,ax
         mov       es,ax
         mov       ax,es:[41ch]

         pushf
         call      dword ptr cs:[Old09]

         cmp       ax,es:[41ch]
         je        Int098

;         mov       ah,1
;         int       16h
;         jz        Int096
;
;         mov       ah,0
;         int       16h
;
;         cmp       ah,48h
;         jne       Int092
;         add       word ptr cs:[XXXK],4600
;         adc       word ptr cs:[XXXK+2],0
;         jmp       short Int098
;
;Int092:  cmp       ah,50h
;         jne       Int096
;         sub       word ptr cs:[XXXK],4600
;         sbb       word ptr cs:[XXXK+2],0
;         jnc       Int098
;         mov       word ptr cs:[XXXK],1
;         mov       word ptr cs:[XXXK+2],0
;         jmp       short Int098
;
Int096:  or        byte ptr cs:[Param],bit0 ; pznak peruen

Int098:  pop       es
         pop       ax
         iret

Int09    ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 08h
; -----------------------------------------------------------------------------

Int08    PROC      FAR

         pushf
         call      dword ptr cs:[Old08]

         cli

         push      ax
         push      bx
         push      ds
         push      es

         push      cs
         pop       ds

         mov       es,ds:[AdrVRAM]
         mov       ah,9
         mov       al," "
         mov       bx,ds:[Poz08]
         mov       es:[bx],ax
         inc       bx
         inc       bx
         cmp       bx,49*2
         jb        Int080
         mov       bx,31*2
Int080:  mov       al,""
         mov       es:[bx],ax
         mov       ds:[Poz08],bx

         inc       word ptr ds:[Cit08]      ; zven tae peteen

         mov       ah,7
         mov       al," "
         xor       bx,bx
Int081:  cmp       byte ptr ds:[bx+Mapa],0
         je        Int082
         dec       byte ptr ds:[bx+Mapa]
         jnz       Int082
         call      DispInd                  ; vymazn indiktoru

Int082:  inc       bx
         cmp       bl,80
         jb        Int081

         pop       es
         pop       ds
         pop       bx
         pop       ax
         iret

Int08    ENDP

; -----------------------------------------------------------------------------
;        nvrat nastaven hodin
; -----------------------------------------------------------------------------

DeInit   PROC      NEAR

; ------ ten hodin systmovho asu (AT)

         mov       dl,8ah                   ; pednastaven na nesmysl
         mov       ah,2
         int       1ah                      ; ten hodin
         cmp       dl,1                     ; peteen pes plnoc ?
         ja        Deinit3                  ; hodiny neplat

; ------ nvrat pznaku peteen pes plnoc

         jne       DeInit2                  ; nen peteen pes plnoc
         xor       ax,ax
         mov       es,ax
         mov       byte ptr es:[470h],dl    ; nvrat pznaku peteen plnoci

; ------ konverze z BCD formtu na binrn

DeInit2: mov       al,ch                    ; hodina
         call      BcdBin                   ; konverze na binrn tvar
         mov       ch,al
         mov       al,cl                    ; minuta
         call      BcdBin                   ; konverze na binrn tvar
         mov       cl,al
         mov       al,dh                    ; sekunda
         call      BcdBin                   ; konverze na binrn tvar
         mov       dh,al

; ------ nastaven asu

         xor       dl,dl                    ; setina sekundy
         mov       ah,2dh
         int       21h                      ; nastaven systmovho asu

DeInit3:
         ret

DeInit   ENDP

; -----------------------------------------------------------------------------
;        Konverze sla z BCD tvaru na binrn
; -----------------------------------------------------------------------------

BcdBin   PROC      NEAR

         push      cx
         mov       ch,al
         and       ch,0fh
         and       al,0f0h
         mov       cl,4
         shr       al,cl
         mov       cl,10
         mul       cl
         add       al,ch
         pop       cx
         ret

BcdBin   ENDP

; -----------------------------------------------------------------------------
;        data
; -----------------------------------------------------------------------------

Poz08    dw        31*2

Stradac  dd        0                        ; stada asu pro 1 impuls
UkazBit  dw        AdrBit                   ; ukazatel k zobrazen bit

Cit08    dw        0                        ; ta prchod INT 08h

Param    db        0                        ; parametry
                                            ;   bit 0: 1=peruen od INT 09h
                                            ;   bit 1: 1=signl je zapnut

Old08    dd        0                        ; pvodn adresa INT 08h
Old09    dd        0                        ; pvodn adresa iNT 09h

AdrVRAM  dw        0b000h                   ; adresa videopamti

VMod     db        3                        ; videomd 3 nebo 7

DnyTxt   db        '------- '               ; 0
         db        'pondeli '               ; 1
         db        '  utery '               ; 2
         db        ' streda '               ; 3
         db        'ctvrtek '               ; 4
         db        '  patek '               ; 5
         db        ' sobota '               ; 6
         db        ' nedele '               ; 7

HelpTxt  db        'DCF_ANAL - analyzator DCF77; (c) Miroslav Nemecek',13,10
         db        'Parametry programu:  1 az 4 ..... cislo portu COM',13,10
         db        '$'

MerTxt   db        ''
         db        '0              50            100            150            200            250   '
         db        '                              ',30,'                             ',30,'                   '
         db        '                               "0"                          "1"               '

InstTxt  db        'CHYBA - port COM'
InstTxt1 db        '1 neni nainstalovan v pocitaci !',13,10,'$'

Mapa     db        80 dup(0)                ; mapa impuls
                                            ; 1 dlek = 3.333333 ms

Code     ENDS
         END       Start
